@init
type Client;

@variables
var balances : [Client]int;

@equals [Client]int @as forall c: Client :: @this[c] == @other[c];

@invariant
forall c: Client :: balances[c] >= 0;

@operations

procedure deposit(accountId: Client, amount: int)
    modifies balances;
    ensures
        forall c: Client ::
        ((c != accountId) ==> (balances[c] == old(balances)[c])) &&
        ((c == accountId) ==> (balances[accountId] == old(balances)[accountId] + amount));

procedure withdraw(accountId: Client, amount: int)
    modifies balances;
    requires balances[accountId] - amount >= 0;
    ensures
        forall c: Client ::
        ((c != accountId) ==> (balances[c] == old(balances)[c])) &&
        ((c == accountId) ==> (balances[accountId] == old(balances)[accountId] - amount));

